package org.qtunes.daap;

import org.qtunes.db.*;
import org.qtunes.web.*;
import java.util.*;
import java.io.*;

class HandlerBrowse extends AbstractHandler {

    Block handleDAAP(DaapServer daap, WebConnection con) throws IOException {
        String field = con.getParameter("__path").substring("/databases/browse/".length());
        Blocks.BlockDefL fieldblock;
        if (field.equals("artists")) {
            fieldblock = Blocks.abar;
        } else if (field.equals("albums")) {
            fieldblock = Blocks.abal;
        } else if (field.equals("genres")) {
            fieldblock = Blocks.abgn;
        } else if (field.equals("composers")) {
            fieldblock = Blocks.abcp;
        } else {
            throw new IOException("Unknown browse field "+field);
        }

        boolean includesortheaders = "1".equals(con.getParameter("include-sort-headers"));
        Database db = daap.getDatabase();
        SmartPlaylist playlist = DaapPlaylist.getSmartPlaylist(con.getParameter("filter"), db);
        List<Track> tracks = playlist.getTracks();
        TreeSet<String> matching = new TreeSet<String>();
        for (int i=0;i<tracks.size();i++) {
            Track track = tracks.get(i);
            if (field.equals("artists")) {
                matching.add((String)track.get(Field.Artist));
            } else if (field.equals("albums")) {
                matching.add((String)track.get(Field.Album));
            } else if (field.equals("genres")) {
                matching.add((String)track.get(Field.Genre));
            } else if (field.equals("composers")) {
                matching.add((String)track.get(Field.Composer));
            }
        }

        ListBlock abro = Blocks.create(Blocks.abro);
        abro.add(Blocks.create(Blocks.mstt, 200));
        abro.add(Blocks.create(Blocks.muty, 0));

        ListBlock results = Blocks.create(fieldblock);
        for (Iterator<String> i = matching.iterator();i.hasNext();) {
            results.add(Blocks.createString(Blocks.mlit, (String)i.next()));
        }
        abro.add(Blocks.create(Blocks.mtco, results.size()));
        abro.add(Blocks.create(Blocks.mrco, results.size()));
        abro.add(results);
        return abro;
    }

}
