package org.qtunes.daap;

import org.qtunes.core.*;
import org.qtunes.db.*;
import org.qtunes.web.*;
import org.qtunes.player.*;
import java.util.*;
import java.io.*;

class HandlerPlaySpec extends AbstractHandler {

    Block handleDAAP(DaapServer daap, WebConnection con) throws IOException {
        ServiceContext context = daap.getServiceContext();
        String command = con.getParameter("command");
        Database db = daap.getDatabase();
        Player player = daap.getPlayer();
        DaapPlaylist playlist = null;

        String spec = con.getParameter("container-spec");
        if (spec.startsWith("'dmap.persistentid:")) {
            long id = Long.decode(spec.substring(19, spec.length()-1));
            playlist = daap.getPlaylist(id);
        }

        if (playlist!=null) {
            player.getPlaylist().clear();
            player.getPlaylist().addAll(playlist.getPlaylist());
            spec = con.getParameter("container-item-spec");
            if (spec!=null && spec.startsWith("'dmap.containeritemid:")) {
                int id = Integer.decode(spec.substring(22, spec.length()-1));
                int index = playlist.getCIDIndex(id);
                context.debug("Skipping to id="+id+" spec="+spec+" index="+index);
                player.setCurrentTrackIndex(index);
            } else {
                context.debug("Failng Skipping to spec="+spec);
            }
            player.setShuffle("1".equals(con.getParameter("shufflestate")));
            daap.getUpdateRevision().bump();
        }
        con.setResponseHeader("Content-encoding", (String)null);
        con.sendResponseHeaders(204, -1);
        return null;
    }

}
