package org.qtunes.daap;

import org.qtunes.core.*;
import org.qtunes.db.*;
import org.qtunes.web.*;
import java.io.*;
import java.util.*;

class HandlerSong extends AbstractHandler {

    void handle(DaapServer daap, WebConnection con) throws IOException {
        ServiceContext context = daap.getServiceContext();
        int track = 0;
        Session session = Session.getCurrentSession();
        String item = con.getParameter("item");
        track = Integer.parseInt(item.substring(0, item.length()-4));
        Track audiofile = daap.getDatabase().getTrack(track);
        File file = audiofile.getFile();
        int filelen = (int)file.length();

        con.setResponseHeader("Content-Type", "audio/mp3");
        con.setResponseHeader("Accept-Ranges", "bytes");
        con.setResponseHeader("Cache-Control", "no-cache");
        String rangeheader = con.getRequestHeader("Range");
        int skip = 0;
        if (rangeheader!=null) {
            skip = Integer.parseInt(rangeheader.substring(6, rangeheader.indexOf("-")));
            con.setResponseHeader("Content-Range", "bytes "+skip+"-"+filelen+"/"+filelen);
        } else {
            session.bumpTracksStarted();
        }
        context.info("Playing "+audiofile.getFile()+" for session "+session.getId());
        Map<String,Object> eventprops = new HashMap<String,Object>();
        eventprops.put("track", audiofile);
        context.fireEvent("startStreaming", new Object[] { "track", audiofile });
        con.sendResponseHeaders(200, filelen);

        OutputStream out = con.getOutputStream();
        byte[] buf = new byte[8192];
        int n;
        InputStream in = null;
        try {
            in = new FileInputStream(file);
            while (skip > 0 && (n=(int)in.skip(skip))>=0) {
                skip -= n;
            }
            while ((n=in.read(buf))>=0) {
                out.write(buf, 0, n);
                session.bumpTraffic(n);
            }
            session.bumpTracksCompleted();
            context.fireEvent("stopStreaming", new Object[] { "track", audiofile });
            out.close();
        } finally {
            if (in!=null) {
                try { in.close(); } catch (IOException e) {}
            }
        }
    }

    Block handleDAAP(DaapServer daap, WebConnection con) throws IOException {
        return null;
    }

}
