package org.qtunes.db.spi.simple;

import org.qtunes.core.*;
import org.qtunes.db.*;
import java.util.*;
import java.io.*;

/**
 * A {@link Matcher} that matches tracks based on their Filename
 */
public class FilenameMatcher implements Matcher {

    public Object getKey(FieldMap map) {
        try {
            String filename = (String)map.get(Field.File);
            return new File(filename.toString()).getCanonicalPath();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    public Object getKey(Track track) {
        try {
            String filename = (String)track.get(Field.File);
            return new File(filename.toString()).getCanonicalPath();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
}
