package org.qtunes.ff.spi.mp3;

import java.nio.*;
import java.io.*;
import org.qtunes.ff.TrackReader;

class TagGenre extends TagText {

    private String value;

    TagGenre() {
    }

    TagGenre(String name, int version, int flags, String genre) {
        super(name, version, flags, encodeGenre(genre));
    }

    private static String encodeGenre(String genre) {
        for (int i=0;i<TrackReader.MP3GENRES.length;i++) {
            if (TrackReader.MP3GENRES[i].equalsIgnoreCase(genre)) {
                return "("+i+")";
            }
        }
        return genre;
    }

    private synchronized void parse() throws IOException {
        if (value==null) {
            try {
                ByteBuffer data = getContent();
                data.rewind();
                byte encoding = data.get();
                value = readEncodedString(data, encoding);
                try {
                    if (value.charAt(0)=='(' && value.charAt(value.length()-1)==')') {
                        value = TrackReader.MP3GENRES[Integer.parseInt(value.substring(1, value.length()-1))];
                    }
                } catch (Exception e) { }
            } catch (BufferUnderflowException e) {
                throw new IOException(e);
            }
        }
    }

    String getValue() throws IOException {
        parse();
        return value;
    }

    public String toString() {
        try {
            return "["+getName()+" value="+getValue()+"]";
        } catch (IOException e) {
            return super.toString();
        }
    }

}
