package org.qtunes.web;

import java.util.*;
import java.io.*;
import java.net.*;

/**
 * An WebConnection that wraps another.
 */
public class WebConnectionWrapper implements WebConnection {

    protected WebConnection con;

    public WebConnectionWrapper(WebConnection con) {
        this.con = con;
    }

    public InetSocketAddress getRemoteAddress() {
        return con.getRemoteAddress();
    }

    public URI getRequestURI() {
        return con.getRequestURI();
    }

    public int getResponseCode() {
        return con.getResponseCode();
    }

    public void close() throws IOException {
        con.close();
    }

    public void sendResponseHeaders(int status, int length) throws IOException {
        con.sendResponseHeaders(status, length);
    }

    public OutputStream getOutputStream() {
        return con.getOutputStream();
    }

    public InputStream getInputStream() {
        return con.getInputStream();
    }

    public String getMethod() {
        return con.getMethod();
    }

    public String getRequestHeader(String key) {
        return con.getRequestHeader(key);
    }

    public List<String> getRequestHeaders(String key) {
        return con.getRequestHeaders(key);
    }

    public Collection<String> getRequestHeaderNames() {
        return con.getRequestHeaderNames();
    }

    public void setResponseHeader(String key, String value) {
        con.setResponseHeader(key, value);
    }

    public void addResponseHeader(String key, String value) {
        con.addResponseHeader(key, value);
    }

    public void setResponseHeader(String key, Date value) {
        con.setResponseHeader(key, value);
    }

    public String getParameter(String key) {
        return con.getParameter(key);
    }

    public List<String> getParameterValues(String key) {
        return con.getParameterValues(key);
    }

    public Map<String,Object> getParameters() {
        return con.getParameters();
    }

    public WebService getWebService() {
        return con.getWebService();
    }

}
