package org.qtunes.web;

import java.util.*;
import java.net.*;
import org.qtunes.core.*;

public class WebServiceFactory implements ServiceFactory {
    
    private ServiceContext context;

    public void startService(ServiceContext context) {
        this.context = context;
    }

    public void stopService(ServiceContext context) {
    }

    public ServiceContext getContext() {
        return context;
    }

    public Collection<Class<?>> getServiceClasses() {
        return Collections.<Class<?>>singleton(WebService.class);
    }

    public Service createService(Class<? extends Service> type, Map<String,String> properties) {
        WebService ws = null;
        if (!properties.containsKey("port")) {
            int port = 0;
            do {
                port = (int)Math.floor(Math.random()*64510 + 1024);
                try {
                    ServerSocket socket = new ServerSocket(port);
                    socket.close();
                } catch (Exception e) {
                    port = 0;
                }
            } while (port==0);
            properties.put("port", Integer.toString(port));
        }

        if (type==WebService.class) {
            try {
                ws = (WebService)Class.forName("org.qtunes.web.spi.sun.SunServer").newInstance();
                properties.put("name", "web.sun."+properties.get("port"));
            } catch (Throwable e) {}
            if (ws==null) {
                try {
                    ws = (WebService)Class.forName("org.qtunes.web.spi.simple.SimpleServer").newInstance();
                    properties.put("name", "web.simple."+properties.get("port"));
                } catch (Throwable e) {}
            }
        }
        return ws;
    }

    public Map<String,Object> reportState() {
        return null;
    }
}
