package org.qtunes.webplayer;

import org.qtunes.core.*;
import org.qtunes.core.util.*;
import org.qtunes.player.*;
import org.qtunes.db.*;
import org.qtunes.web.*;
import java.net.*;
import java.io.*;
import java.nio.*;
import java.nio.channels.*;
import java.util.*;

class ImageHandler implements WebHandler {
   
    private final ServiceContext context;
    private final Database db;

    ImageHandler(WebPlayer player) {
        this.context = player.getContext();
        this.db = context.getService(Database.class);
    }

    public void handle(WebConnection con) throws IOException {
        int track = Integer.parseInt(con.getParameter("track"));
        int mw = Integer.parseInt(con.getParameter("mw"));
        int mh = Integer.parseInt(con.getParameter("mh"));
        ByteBuffer buf = ImageScaler.getInstance().getScaledImage(db.getTrack(track).getImageBuffer(), mw, mh, "JPEG");

        con.setResponseHeader("Server", context.getSoftwareName()+"/"+con.getWebService().getContext().getServiceName());
        con.setResponseHeader("Date", new Date());
        if (buf == null) {
            con.sendResponseHeaders(404, -1);
        } else {
            con.addResponseHeader("Content-Type", "image/png");
            con.sendResponseHeaders(200, buf.limit());
            OutputStream out = con.getOutputStream();
            Channels.newChannel(out).write(buf);
            out.close();
        }
    }

}
